searchNodes=[{"doc":"","ref":"Viewplex.html","title":"Viewplex","type":"module"},{"doc":"This module provides the base implementation of all components. When useing the module, you can pass a list of fields as you would for Kernel.defstruct/1... The struct fields will be used to filter/ cast the assigns passed to the directly to the template. Bear in mind that this module inner implementation relies heavily on Phoenix.View.Examples No assigns allowed: defmodule MyComponent do use Viewplex.Component end Allowing only the :name property: defmodule MyComponent do use Viewplex.Component, [:name] end Allowing the :name property and defining a default value: defmodule MyComponent do use Viewplex.Component, [name: &quot;John&quot;] end","ref":"Viewplex.Component.html","title":"Viewplex.Component","type":"module"},{"doc":"This module holds the internal representation of a component data. It implements the Phoenix.HTML.Safe protocol.","ref":"Viewplex.HTML.CompData.html","title":"Viewplex.HTML.CompData","type":"module"},{"doc":"This module holds the internal representation of a slot data. It implements the Phoenix.HTML.Safe protocol.","ref":"Viewplex.HTML.SlotData.html","title":"Viewplex.HTML.SlotData","type":"module"},{"doc":"Helper functions to create components and slots.","ref":"Viewplex.Helpers.html","title":"Viewplex.Helpers","type":"module"},{"doc":"","ref":"Viewplex.Helpers.html#component/1","title":"Viewplex.Helpers.component/1","type":"macro"},{"doc":"","ref":"Viewplex.Helpers.html#component/2","title":"Viewplex.Helpers.component/2","type":"macro"},{"doc":"","ref":"Viewplex.Helpers.html#component/3","title":"Viewplex.Helpers.component/3","type":"macro"},{"doc":"","ref":"Viewplex.Helpers.html#slot/2","title":"Viewplex.Helpers.slot/2","type":"macro"},{"doc":"ViewplexA convenience library that allows you to further separate your views into scoped components.","ref":"README.html","title":"Viewplex","type":"extras"},{"doc":"Add viewplex to your list of dependencies in mix.exs:def deps do [ {:viewplex, &quot;~&gt; 0.2.0&quot;} ] endDocumentation can be be found at https://hexdocs.pm/viewplex.","ref":"README.html#installation","title":"Viewplex - Installation","type":"extras"},{"doc":"ConfigurationConfigure where your components are located with:config :viewplex, path: &quot;lib/my_app_web/components&quot;ComponentsCreate new components by use-ing the Viewplex.Component module and creating a corresponding template with the same name.lib/my_app_web/components/label_component.ex:defmodule LabelComponent do use Viewplex.Component endlib/my_app_web/components/label_component.html.eex:Hello World!You can also use inline templates:defmodule LabelComponent do use Viewplex.Component def call(_module, assigns), do: ~E&quot;Hello World&quot; endThen, call your component inside a template:&lt;%= component LabelComponent %&gt;Remember to import Viewplex.Helpers in your views.Naming ConventionsComponents should follow the same convention as Elixir modules.So, if you have a MyAppWeb.Components.LabelComponent module, the file should be located at: my_app_web/components/label_component.ex. We also support (and encourage) prefixing the component module name with &quot;Component&quot;, following the existant naming convention for Phoenix's views and controllers.Feature foldersIntead of placing your components in the root folder, you can also group your components like this:my_app_web/components/label my_app_web/components/label/label_component.ex my_app_web/components/label/label_component.html.eexFiltering assignsComponents can also define fields:defmodule LabelComponent do use Viewplex.Component, [:message] end&lt;%= component LabelComponent, message: &quot;Hello World&quot; %&gt;Fields defined in the component will be available as an assign in your template:&lt;label&gt;&lt;%= @message %&gt;&lt;/label&gt;This should allow you to simply pass down a map of assigns that will be filtered before actually invoking the component:&lt;%= component LabelComponent, assigns %&gt;Content blocks and slotsYou can also pass content to your components:Inline:&lt;%= component LabelComponent, &quot;Hello World&quot; %&gt;Or using do blocks:&lt;%= component LabelComponent do %&gt; Hello World &lt;% end %&gt;This will be available as an assign under the :content key:&lt;label&gt;&lt;%= @content &gt;&lt;/label&gt;Using named slots:&lt;%= component LabelComponent do %&gt; &lt;% slot(:message, &quot;Hello World&quot;) %&gt; &lt;% end %&gt;&lt;label&gt;&lt;%= @slots.message &gt;&lt;/label&gt;Notice that we are using &lt;% instead of &lt;%=. This is necessary because if you output the return of the slot/2 function, you'll actually be rendering its content inside the component's block.This happens because Viewplex will scan the component block for slot/2 function calls and then extract the slot content so it is available in the template. MoutingYou can also customize how components are mounted by overriding the mount/1 function:defmodule LabelComponent do use Viewplex.Component, [:message] def mount(assigns) do user = Users.get_user(assigns.user_id) {:ok, Map.put(assigns, :user, user)} end endOr disabling the component entirely by returning an {:error, reason} tuple:defmodule LabelComponent do use Viewplex.Component, [:message] def mount(assigns) do case Users.get_user(assigns.user_id) do nil -&gt; {:error, &quot;could not fetch user&quot;} user -&gt; {:ok, Map.put(assigns, :user, user)} end end end","ref":"README.html#usage","title":"Viewplex - Usage","type":"extras"},{"doc":"[ ] Improve documentation[ ] Add real use-cases as examples[ ] Improve function typespecs[x] Support defining components inside group folder (aka &quot;feature folder&quot;)[x] Publish to Hex[ ] Scaffold and setup tasks[ ] Component documentation generation[ ] Get default component path based on app name[ ] Add test samples on README[ ] Log mount errors using Logger","ref":"README.html#todo-s","title":"Viewplex - Todo's","type":"extras"}]